package info.aspirecn.iov.sjjh.supplier10000043;

import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.iov.sjjh.supplier10000043.constant.SjjhConstant;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.core.env.Environment;
import org.springframework.data.redis.core.BoundHashOperations;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.util.StopWatch;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

@SpringBootApplication
@EnableConfigurationProperties
@EnableScheduling
@Slf4j
@ComponentScan("info.aspirecn.rdc.aspirecloud.node.except")
@ComponentScan("info.aspirecn.rdc.aspirecloud.node.brave")
@ComponentScan("info.aspirecn.iov.sjjh.supplier10000043")
@EnableFeignClients(basePackages = {"info.aspirecn.iov.sjjh"})
public class App  {

    public static void main(String[] args) {
        StopWatch watch = new StopWatch();
        watch.start();

        ApplicationContext context = SpringApplication.run(App.class, args);
        Environment environment = context.getBean(Environment.class);
        String applicationName = environment.getProperty("spring.application.name");



        watch.stop();
        log.info("{} 启动完毕，times={}s", applicationName, watch.getTotalTimeSeconds());
    }

}
